/*****************************************************************************
 
 i2crtc.c - RTC over I2C library 
		Designed for Atmels AVR MCUs
 
 Copyright (C) 2014 Patrick Eydt
 
*****************************************************************************/

/*
	Version 1.00
*/

#include <avr/pgmspace.h>
#include <stdbool.h>
#include <stdint.h> 
#include "main.h"
#include <util/delay.h>
#include "i2crtc.h"
#include "i2cmaster.h"


/*--------- Initialisierung ---------*/

void rtc_init void
{	
	i2c_start_wait ( RTC_I2C_DEVICE + I2C_WRITE ) ;
	i2c_write ( RTC_DCF77_config + I2C_WRITE ) ;
	i2c_write ( DCFLED | DCDIE | DCFE ) ;
	i2c_stop ( ) ;
	_delay_ms ( 5 ) ;
	
	i2c_start_wait ( RTC_I2C_DEVICE+I2C_WRITE ) ;
	i2c_write ( RTC_periodic_int+I2C_WRITE ) ;
	i2c_write ( PIM2 );
	i2c_stop ( ) ;
	_delay_ms ( 5 ) ;

	i2c_start_wait ( RTC_I2C_DEVICE + I2C_WRITE ) ;
	i2c_write ( RTC_per_int_conig + I2C_WRITE ) ;
	i2c_write ( PIE ) ;
	i2c_stop ( ) ;
	_delay_ms ( 5 ) ;
}


/*--------- Schreibe Daten auf RTC ---------*/

void rtc_write_i2c(uint8_t value)
{
	i2c_start_wait ( RTC_I2C_DEVICE + I2C_WRITE ) ;
	i2c_write ( value ) ;
	i2c_stop ( ) ;
}


/*---------	Lese Daten von RTC ---------*/

/*uint8_t lcd_read_i2c(void) 
{


	i2c_start_wait(RTC_I2C_DEVICE+I2C_READ);
	rtcdata = i2c_readNak();
	i2c_stop();
	return lcddata;
}
*/

//-	Read one complete byte via i2c from display

uint8_t rtc_read_second(bool mode)  
{
	uint8_t lo;

	i2c_start_wait ( RTC_I2C_DEVICE + I2C_WRITE ) ;
	i2c_readNak ( RTC_second ) ;
	lo = rtc_read(mode);
	return lo;
}

uint8_t rtc__read_minute(bool mode)  
{
	uint8_t hi;

	hi &= ( 0b01110000 ;)

	hi = lcd_read(mode);
	lo = lcd_read(mode);
	return (hi << 4) + (lo & 0x0F);
}

uint8_t rtc_read_hour(bool mode)  
{
	uint8_t hi, lo;

	hi &=

	hi = lcd_read(mode);
	lo = lcd_read(mode);
	return (hi << 4) + (lo & 0x0F);
}

uint8_t rtc_read_day(bool mode)  
{
	uint8_t hi, lo;

	hi &=

	hi = lcd_read(mode);
	lo = lcd_read(mode);
	return (hi << 4) + (lo & 0x0F);
}

uint8_t rtc_read_month(bool mode)  
{
	uint8_t hi, lo;

	hi &= ( 0b01110000 );
	
	hi = rtc_read(mode);
	lo = rtc_read(mode);
	return (hi << 4) + (lo & 0x0F);
}

uint8_t rtc_read_year(bool mode)  
{
	uint8_t hi, lo;

	hi &=

	hi = lcd_read(mode);
	lo = lcd_read(mode);
	return (hi << 4) + (lo & 0x0F);
}


//-	Check if busy

bool rtc_busy(void) {
	uint8_t state;
    
    state = rtc_getbyte(RTC_ADDRESS);
	if (state & (1 << 7)) {
        return true;
    } else {
        return false;
    }
}
